Attribute VB_Name = "THREAD_L"

Option Explicit

Sub GetIncoming()
  Dim I As Integer
  Dim Buffer As String * 1024
  Dim Count As Integer
  Count = SioGets(ThePort, Buffer, 1024)
  If Count > 0 Then
    For I = 1 To Count
      Call DisplayChar(THREAD, Asc(Mid$(Buffer, I, 1)))
    Next I
  End If
End Sub

Sub GoOffLine()
  Dim Code As Integer
  OnLineFlag = 0
  ' terminate the thread
  Code = TerminateThread(ThreadData.Handle, 0)
  'shut down the port
  Code = SioDone(ThePort)
End Sub

Sub GoOnLine()
  Dim I As Integer
  Dim Code As Long
  Dim RxQueSize As Integer
  Dim TxQueSize As Integer
  Dim ThreadID As Long
  If OnLineFlag Then
    Exit Sub
  End If
  'reset the port (1024 byte RX buffer & 256 byte TX buffer)
  RxQueSize = 1024
  TxQueSize = 256
  Code = SioReset(ThePort, RxQueSize, TxQueSize)
  If Code < 0 Then
    Call SayError(THREAD, Code)
    Exit Sub
  End If
  'set baud rate
  Code = SioBaud(ThePort, TheBaudCode)
  'call Aborting() if detect error after resetting port
  Call DisplayLine(THREAD, "COM" + LTrim$(Str$(1 + ThePort)) + " reset")
  'set DTR & RTS
  Code = SioDTR(ThePort, Asc("S"))
  Code = SioRTS(ThePort, Asc("S"))
  'turn on hardware flow control
  '''Code = SioFlow(ThePort, Asc("H"))
  ' set parms
  Code = SioParms(ThePort, NoParity, OneStopBit, WordLength8)
  ' create thread which will block for incoming serial data
  ThreadData.Port = ThePort
  ThreadData.Handle = CreateThread(0, 0, AddressOf TheThread.TheThreadSub, ThreadData, 0, ThreadID)
  '''Call DisplayLine(THREAD, "ThreadHandle=" + Str$(ThreadHandle))
  ' we're online !
  OnLineFlag = 1
End Sub

Sub SetBaud()
Dim Code As Integer
'Baudrate can be changed while running
Code = SioBaud(ThePort, TheBaudCode)
End Sub

Sub ShowConfig()
  Dim A As String
  Dim B As String
  Dim c As String
  If OnLineFlag Then
    A = " (Online)"
  Else
    A = " (Offline)"
  End If
  B = "COM" + LTrim$(Str$(ThePort + 1))
  c = " @ " + BaudRateTable(TheBaudCode) + " "
  THREAD.Caption = "THREAD: " + B + c + A
End Sub

