Attribute VB_Name = "modServiceControl"
Private SVCS As clsServices
Private SVC As clsService

Public Enum ServiceStatus
    svcStop = 1
    svcStart = 2
    svcPause = 3
    svcDisable = 4
End Enum

Public Function EnumerateServices(Optional strMachineName) As Variant

    Dim DataOut As String
    
    Set SVCS = New clsServices
    
    If Not IsMissing(strMachineName) Then SVCS.ComputerName = strMachineName
        
        For nLoop = 1 To SVCS.Count
        
                If SVCS(nLoop).CurrentState = [continue pending] Then
                    StatusText = "Continue Pending"
                ElseIf SVCS(nLoop).CurrentState = [Pause Pending] Then
                    StatusText = "Pause Pending"
                ElseIf SVCS(nLoop).CurrentState = Paused Then
                    StatusText = "Paused"
                ElseIf SVCS(nLoop).CurrentState = Running Then
                    StatusText = "Running"
                ElseIf SVCS(nLoop).CurrentState = [Start Pending] Then
                    StatusText = "Start Pending"
                ElseIf SVCS(nLoop).CurrentState = [Stop Pending] Then
                    StatusText = "Stop Pending"
                ElseIf SVCS(nLoop).CurrentState = Stopped Then
                    StatusText = "Stopped"
                End If
                
                DataOut = DataOut & CStr(nLoop) & "," & SVCS(nLoop).ComputerName & "," _
                & SVCS(nLoop).DisplayName & "," & StatusText & ","
            
        Next nLoop
        
    EnumerateServices = Split(DataOut, ",")
    
End Function

Public Function SControl(strMachine As String, iServiceNum As Integer, strCommand As String) As String

    Set SVCS = New clsServices
    
        SVCS.ComputerName = Trim(strMachine)
            
            Select Case UCase(strCommand)
            
                Case "START"
                    
                    If SVCS(iServiceNum).CurrentState <> Stopped Then
                        SControl = "Service NOT Stopped"
                    Else
                    SVCS(iServiceNum).StartService
                    Do
                    DoEvents
                    SVCS(iServiceNum).Refresh
                    Loop Until SVCS(iServiceNum).CurrentState = Running
                    SControl = "Started"
                    End If
                    
                Case "STOP"
                
                    If SVCS(iServiceNum).CurrentState <> Running Then
                        SControl = "Service NOT Running"
                    Else
                    SVCS(iServiceNum).StopService
                    Do
                    DoEvents
                    SVCS(iServiceNum).Refresh
                    Loop Until SVCS(iServiceNum).CurrentState = Stopped
                    SControl = "Stopped"
                    End If
                    
                Case "PAUSE"
                
                    If SVCS(iServiceNum).CurrentState <> Running Then
                        SControl = "Service NOT Running"
                    Else
                    SVCS(iServiceNum).PauseService
                    Do
                    DoEvents
                    SVCS(iServiceNum).Refresh
                    Loop Until SVCS(iServiceNum).CurrentState = Paused
                    SControl = "Paused"
                    End If
                    
                Case "RESTART"
                
                    SVCS(iServiceNum).StopService
                    Do
                    DoEvents
                    SVCS(iServiceNum).Refresh
                    Loop Until SVCS(iServiceNum).CurrentState = Stopped
                    
                    SVCS(iServiceNum).StartService
                    Do
                    DoEvents
                    SVCS(iServiceNum).Refresh
                    Loop Until SVCS(iServiceNum).CurrentState = Running
                    SControl = "Restarted"
                    
                Case "RESUME"
                
                    If SVCS(iServiceNum).CurrentState <> Paused Then
                        SControl = "Service NOT Paused"
                    Else
                    SVCS(iServiceNum).ContinueService
                    Do
                    DoEvents
                    SVCS(iServiceNum).Refresh
                    Loop Until SVCS(iServiceNum).CurrentState = Running
                    SControl = "Resumed"
                    End If
                    
            End Select
            
End Function
