Attribute VB_Name = "modTelnet"
Public Declare Function GetActiveWindow Lib "user32" () As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Enum sock_state
    socket_inuse = 1
    socket_unused = 2
End Enum

Public Enum eAccessLevel

        User = 0
        Administrator = 1
        Supervisor = 2
        SysOp = 3
        SuperUser = 4

End Enum

Public Type socket_data
    socket_id           As Long
    socket_state        As sock_state
    Username            As String
    Password            As String
    RealName            As String
    AccessLevel         As eAccessLevel
    bLoggedIn           As Boolean
    bAcceptedID         As Boolean
    Last_Logon          As String
End Type

Public Type server_data
    socket_id           As Long
    socket_state        As sock_state
    ServerName          As String
    ServerIP            As String
    Status              As String
    ServiceControl      As Boolean
    DiskMgmt            As Boolean
    MemStatus           As Boolean
    RebootControl       As Boolean
    Shell               As Boolean
End Type

Public Type telnet_data
    socket_id           As Long
    socket_state        As sock_state
End Type

Public Type AccessControlList_Data
    PermittedIP         As String
End Type

Public structTelnet()  As telnet_data
Public structTCP()     As socket_data
Public structServer()  As server_data
Public structACL()     As AccessControlList_Data
Public db              As Database
Public rsUsers         As Recordset
Public rsACL           As Recordset



Public Function Encrypt(TextToEncrypt, ByVal intkey As Integer) As String
    Dim EncryptedText As String
    Randomize
    Dim varBlah() As String


    If intkey = 0 Then
        intkey = 1
    End If
    'create an array equal to the size of th
    '     e given key
    ReDim varBlah(intkey - 1) As String


    If TextToEncrypt <> "" Then
        Dim varCrypt As String
        Dim varTemp As Long
        Dim i As Long
        Dim j As Integer


        For i = 1 To Len(TextToEncrypt)
            'convert the string into an ascii value
            varTemp = Asc(Mid$(TextToEncrypt, i, 1))
            'convert the ascii value into a string
            varCrypt = Chr$(varTemp - i)
            EncryptedText = EncryptedText + varCrypt
            'cycle through the array and add to the
            '     encrypted string a random
            'character


            For j = LBound(varBlah()) To UBound(varBlah())
                varBlah(j) = Chr$((255 * Rnd + 1))
                EncryptedText = EncryptedText + varBlah(j)
            Next
        Next
    End If
    Encrypt = EncryptedText
End Function


Public Function Decrypt(TextToDecrypt, ByVal intkey As Integer) As String
    Dim DecryptedText As String


    If TextToDecrypt <> "" Then
        Dim varCrypt As String
        Dim varTemp As Long


        If intkey = 0 Then
            intkey = 1
        End If
        Dim i As Long
        Dim j As Integer
        j = 1
        'takes only the characters in the encryp
        '     ted string, based upon the
        'key value


        For i = 1 To Len(TextToDecrypt) Step (intkey + 1)
            varTemp = Asc(Mid$(TextToDecrypt, i, 1))
            varCrypt = Chr$(varTemp + j)
            DecryptedText = DecryptedText + varCrypt
            j = j + 1
        Next
    End If
    Decrypt = DecryptedText
End Function

Public Function GetAL(intAL As Integer) As String

    Select Case intAL
    
        Case 0
        GetAL = "User"
        Case 1
        GetAL = "Administrator"
        Case 2
        GetAL = "Supervisor"
        Case 3
        GetAL = "SysOp"
        Case 4
        GetAL = "Super User"
        
    End Select
    
End Function

Public Function boolMaskCompare(strMask As String, strCandidate As String)
    ' Given a mask (optionally with * and ?
    '     strings) and a candidate as a string,
    ' return TRUE if the candidate matches t
    '     he mask
    ' The mask can start with an *, a ? or a
    '     nother character
    ' The mask is not assumed to contain any
    '     mask characters.
    ' In the event that no mask characters a
    '     re present, a straight comparison is off
    '     ered.
    Dim bool As Boolean ' Holds the temporary result, assumed True until comparison fails
    bool = True
    ' Declare counters to step along the str
    '     ings
    Dim lngM As Long ' Counter For the mask String
    Dim lngC As Long ' Counter For the candidate String
    lngM = 1
    lngC = 1
    ' Loop until either string is exhausted
    '     or a match fails


    While lngM <= Len(strMask) And lngC <= Len(strCandidate) And bool
        ' If we mask a single character, grant t
        '     hem the match


        If Mid(strMask, lngM, 1) = "?" Then ' advance both pointers to skip this match
            lngM = lngM + 1
            lngC = lngC + 1
        Else


            If Mid(strMask, lngM, 1) = "*" Then ' advance the Mask pointer to skip this character
                lngM = lngM + 1


                If lngM > Len(strMask) Then
                    lngC = Len(strCandidate) + 1 ' If * is last char, we've won
                Else
                    ' If strMask(lngM) matches strCandidate
                    '     before end of c we continue


                    While (Mid(strMask, lngM, 1) <> Mid(strCandidate, lngC, 1)) And lngC <= Len(strCandidate)
                        lngC = lngC + 1
                    Wend


                    If lngC > Len(strCandidate) Then
                        bool = False
                    Else
                    End If
                End If
            Else


                If Mid(strMask, lngM, 1) = Mid(strCandidate, lngC, 1) Then
                    lngM = lngM + 1
                    lngC = lngC + 1
                Else
                    bool = False
                End If
            End If
        End If
    Wend
    boolMaskCompare = bool ' Return the result
End Function

Public Function SpawnProcess(sFilename As String) As Variant

       Dim ltemp As Long
       Dim Msg  As String
       Dim X    As Long
       
       If InStrRev(sFilename, "\") > 0 Then
            sDir = Left(sFilename, InStrRev(sFilename, "\") - 1)
       Else
            sDir = ""
       End If
       
       ltemp = GetActiveWindow()
       
       X = ShellExecute(ltemp, "Open", sFilename, "", sDir, 1)
       
        If X = 2 Then
            SpawnProcess = "Error spawning proccess ... 'File not found'"
        ElseIf X > 32 Then
            SpawnProcess = "File '" & sFilename & "' was spawned sucessfully."
        End If


End Function
